%% function "MIMO_Part_Asyn_IWFA.m"
% This is the algorithm simulation - MIMO Partially Asynchronous IWFA.
% It will be called by "FYT.m".
function Rate_Part_Asyn = MIMO_Part_Asyn_IWFA(Nit, Q, N_T, H, R_n, P_max, P_init, B)
P = P_init;
% updating schedule for each link
T = ones(Q,1);
% information rate
Rate_tmp = zeros(Q,1);
Rate_Part_Asyn = zeros(Q,1);
% memory for power interference
P_inter_mem = P;
for i=1:(B-1)
    P_inter_mem = [P_inter_mem P];
end
T_inter = ones(Q,Q);
P_inter = P;

% iterations
for i=1:Nit
    % calculate the current information rate
    for index=1:Q
        Rate_tmp(index) = R_q(R_n, Q, H, P, N_T, index);
    end
    Rate_Part_Asyn = [Rate_Part_Asyn Rate_tmp];
    % update the power allocation
    for index=1:Q
        if T(index) == i
            % update the next schedule
            T(index) = i + 1 + floor(rand(1)*B);
            % perceive the interference from other links
            for j=1:Q
                if index==j
                    T_inter(index,j)=i;
                else
                    T_inter(index,j) = max(T_inter(index,j), i-floor(B*rand));
                end
                P_inter{j} = P_inter_mem{j, i+1-T_inter(index,j)};
            end
            % waterfilling
            P{index} = WF_q(R_n, Q, H, P_inter, P_max, N_T, index);
        end
    end
    % update the memory for power interference
    if B>=2
        P_inter_mem(1:Q,2:B)=P_inter_mem(1:Q,1:B-1);
        P_inter_mem(1:Q,1)=P;
    else
        P_inter_mem = P;
    end
end

Size_Rate_Part_Asyn = size(Rate_Part_Asyn);
Rate_Part_Asyn = Rate_Part_Asyn(1:Size_Rate_Part_Asyn(1),2:Size_Rate_Part_Asyn(2));
end