%% function "MIMO_Sequ_IWFA.m"
% This is the algorithm simulation - MIMO Sequential IWFA.
% It will be called by "FYT.m".
function Rate_Sequ = MIMO_Sequ_IWFA(Nit, Q, N_T, H, R_n, P_max, P_init)
P = P_init;
Rate_tmp = zeros(Q,1);
Rate_Sequ = zeros(Q,1);

for i=1:Nit
    % calculate the current information rate
    for index=1:Q
        Rate_tmp(index) = R_q(R_n, Q, H, P, N_T, index);
    end
    Rate_Sequ = [Rate_Sequ Rate_tmp];
    % update the power allocation
    index = mod(i,Q) + 1;
	P{index} = WF_q(R_n, Q, H, P, P_max, N_T, index);
end

Size_Rate_Sequ = size(Rate_Sequ);
Rate_Sequ = Rate_Sequ(1:Size_Rate_Sequ(1),2:Size_Rate_Sequ(2));
end