%% function "MIMO_Simu_IWFA.m"
% This is the algorithm simulation - MIMO Simultaneous IWFA.
% It will be called by "FYT.m".
function Rate_Simu = MIMO_Simu_IWFA(Nit, Q, N_T, H, R_n, P_max, P_init)
P = P_init;
Rate_tmp = zeros(Q,1);
Rate_Simu = zeros(Q,1);

for i=1:Nit
    % calculate the current information rate
    for index=1:Q
        Rate_tmp(index) = R_q(R_n, Q, H, P, N_T, index);
    end
    Rate_Simu = [Rate_Simu Rate_tmp];
    % update the power allocation
    P_inter = P;
    for index=1:Q
        P{index} = WF_q(R_n, Q, H, P_inter, P_max, N_T, index);
    end
end

Size_Rate_Simu = size(Rate_Simu);
Rate_Simu = Rate_Simu(1:Size_Rate_Simu(1),2:Size_Rate_Simu(2));
end