%% function "Random_Init.m"
% It initialize the links, channel information and noise which will be
% needed later. It will be called by "FYT.m".
function [Nit Q N_T N_R H R_n P_max P_init] = Random_Init
Multiples = 2;      
Nit = 100;          % initialize the number of iterations
Q = 4;              % initialize the number of links
N_T = ones(Q,1)*4;  % initialize the number of transimitters for each link
N_R = N_T;          % initialize the number of receivers for each link

% initialize the channel information
H = cell(Q);
for k = 1:Q
    for j = 1:Q
        % channel information
        if (k==j)
            while (true)
                H{j,k}=complex((1/sqrt(2))*randn(N_R(k), N_T(j)),(1/sqrt(2))*randn(N_R(k), N_T(j)));
                if det(H{j,k})~=0 % check the nonsingularity
                    break;
                end
            end
        % interference
        else
            H{j,k}=complex((1/sqrt(2))*randn(N_R(k), N_T(j)),(1/sqrt(2))*randn(N_R(k), N_T(j)))/Multiples;
        end
    end
end

% initialize the noise covariance matrix R_n
n = cell(Q,1);
R_n = cell(Q,1);
for k = 1:Q
    while (true)
        n{k} = complex((1/sqrt(2))*randn(N_R(k),1),(1/sqrt(2))*randn(N_R(k),1))/Multiples;
        R_n{k} = n{k}*n{k}';
        if det(R_n{k})~=0 % check the nonsingularity
            break;
        end
    end
end

% initialize the power constraint and power covariance matrix P
P_max = ones(Q,1);
P_init = cell(Q,1);
for k = 1:Q
    P_init{k}=zeros(N_T(k));
    P_init{k}(1,1)=P_max(k);
end
end