%% function "WF_q.m"
% It's the waterfilling operator updates link "index"'s power allocation
% according to other links' interference and the noise. 
% It will be called by "MIMO_Sequ_IWFA.m", "MIMO_Simu_IWFA.m" and
% "MIMO_Part_Asyn_IWFA.m"
function WF_index = WF_q(R_n, Q, H, P_inter, P_max, N_T, index)
R_neg_index = Rate_neg_q(R_n, Q, H, P_inter, index);
[U_index D_index] = eig(H{index,index}'*inv(R_neg_index)*H{index,index});

% calculate the water level u_q
D_inv_diag = diag(inv(D_index));
D_inv_diag = sort(D_inv_diag, 'descend');

rest_start = 1;
stop = false;
while true
    n_T = N_T(index)-rest_start+1;
    u_q = (P_max(index)+sum(D_inv_diag(rest_start:N_T(index))))/n_T;
    for i = rest_start:N_T(index)
        if (u_q >= D_inv_diag(i))
            if i == rest_start
                stop = true;
            else
                rest_start = rest_start + 1;
            end
            break;
        end
    end
    if stop
        break;
    end
end

% waterfilling
tmp=real(u_q*eye(N_T(index))-inv(D_index));
WF_index = U_index*max(zeros(N_T(index)),tmp)*U_index';
end